Unit SendKey;
Interface
Uses Windows;
Procedure SendKeys(S:String);
Procedure SimulateKeystroke(Key:Byte; Extra:DWord);
Procedure SimulateKeyDown(Key:Byte);
Procedure SimulateKeyUp(Key:Byte);
Implementation
Procedure SimulateKeyDown(Key:Byte);
	Begin
		Keybd_Event(Key,0,0,0);
	End;
Procedure SimulateKeyUp(Key:Byte);
	Begin
		Keybd_Event(Key,0,KEYEVENTF_KEYUP,0);
	End;
Procedure SimulateKeystroke(Key:Byte; Extra:DWord);
	Begin
		Keybd_Event(Key,Extra,0,0);
		Keybd_Event(Key,Extra,KEYEVENTF_KEYUP,0);
	End;
Procedure SendKeys(S:string);
	Var
		I		:Integer;
		Flag		:Bool;
		W		:Word;
	Begin
		Flag := not GetKeyState(VK_CAPITAL) and 1 = 0;
		If Flag then
			SimulateKeystroke(VK_CAPITAL, 0);
		For I := 1 to Length(S) do Begin
			W := VkKeyScan(S[I]);
			If ((HiByte(W) <> $FF) and (LoByte(W) <> $FF)) then Begin
				If HiByte(W) and 1 = 1 then
					SimulateKeyDown(VK_SHIFT);
				SimulateKeystroke(LoByte(W),0);
				If HiByte(W) and 1 = 1 then
					SimulateKeyUp(VK_SHIFT);
			End;
		End;
		If Flag then
			SimulateKeystroke(VK_CAPITAL, 0);
	End;
End.
